#include <fstream>
#include <iostream>
#include <string>

int main(int argc, char** argv) {
    std::string in, out;
    for(int i = 1; i < argc; ++i) {
        if(argv[i] == std::string("-o")) {
            ++i;
            if(i == argc) return 2;
            out = argv[i];
        } else {
            in = argv[i];
        }
    }
    if(out[out.size()-1] != '/' && out[out.size()-1] != '\\')
        out += "/";
    std::string base(out + in.substr(0, in.rfind('.')));
    std::ifstream compil(in.c_str());
    std::ofstream header((base + ".h").c_str());
    std::ofstream source((base + ".cpp").c_str());
    std::string line;
    header << "#pragma once" << std::endl;
    source << "#include \"" << in.substr(0, in.rfind('.')) << ".h" << "\"" << std::endl;
    while(std::getline(compil, line)) {
        if(line.substr(0, 6) == "import") {
            line = line.substr(6, line.size() - 15); // ".compil\";"
            header << "#include " << line << ".h\"" << std::endl;
        } else if(line.substr(0, 4) == "def ") {
            line = line.substr(4, line.size() - 4);
            source << line << std::endl;
            header << line << ';' << std::endl;
        } else {
            source << line << std::endl;
        }
    }
}
